rm /dobot/userdata/project/optitrack_bindata -f
#update
if [ -f "/dobot/userdata/project/bin.tar.gz" ]; then
	ls /dobot/userdata/project/bin.tar.gz -l
	echo "...... find /dobot/userdata/project/bin.tar.gz, start update"
	cd /dobot/
	echo "...... start rm bin,update"
	rm /dobot/bin/ -rf
	tar zxvf /dobot/userdata/project/bin.tar.gz -C /dobot
	rm -f /dobot/userdata/project/bin.tar.gz
	if [ -d "/dobot/system/home/ftp/PlcLogic/Application" ];then
                cp -rf /dobot/system/home/ftp/PlcLogic/Application /home/ftp/PlcLogic
                rm -rf /dobot/system/home/ftp/PlcLogic/Application
        fi
	sync
	echo "..... update finish"
fi

#check update
rm -rf /tmp/update
if [ -b /dev/sda1 ]; then
    echo "Runing mount > /dobot/usb/"
    mkdir -p /dobot/usb
	count=1
	while [ $count -le 30 ]; do
		mount /dev/sda1 /dobot/usb
		ls /dobot/usb/ >> /ovalgeee
		if [ -f /dobot/usb/Controller_6R.tar.gz ]; then
			rm -rf /dobot/bin
			tar -zxvf /dobot/usb/Controller_6R.tar.gz -C /dobot
			if [ ! -d "/dobot/system/home/ftp/PlcLogic/Application" ];then
				mkdir "/dobot/system/home/ftp/PlcLogic/Application"
			fi
			if [ -d "/dobot/system/home/ftp/PlcLogic/Application" ];then
                cp -rf /dobot/system/home/ftp/PlcLogic/Application /home/ftp/PlcLogic
                rm -rf /dobot/system/home/ftp/PlcLogic/Application
				echo "..... update codesys"
			fi
			touch /tmp/update
			sync
			umount /dobot/usb
			break
		fi
		sleep 0.01
		count=$(($count + 1))
	done
else
    echo "Runing WLAN......"
fi

if [ ! -d "/dobot/logs" ];then
	mkdir "/dobot/logs"
fi
mount /dev/mmcblk3p4 /dobot/logs

if [ -d "/home/ovalgee/Projects/RobotController_4R/project/Robot4Axis_win/bin" ]; then
	topdir=/home/ovalgee/Projects/RobotController_4R/project/Robot4Axis_win/bin
	export PATH=/home/ovalgee/Projects/toolchain/arm-linux-gcc-6.3.1/bin:/home/ovalgee/Projects/iSCARA/Linux/toolchain/i686-linux-gcc-5.1.0/bin:$PATH
	export LD_LIBRARY_PATH=/home/ovalgee/Projects/toolchain/i686-linux-gcc-5.1.0/lib:$LD_LIBRARY_PATH
	qtdir=$topdir/lib/qt
elif [ -d "/home/ovalgee/Projects/iSCARA/RobotController_4R/trunk/RobotController/Linux/project/Robot4Axis_win/bin" ]; then
	topdir=/home/ovalgee/Projects/iSCARA/RobotController_4R/trunk/RobotController/Linux/project/Robot4Axis_win/bin
	export PATH=/home/ovalgee/Projects/iSCARA/Linux/toolchain/arm-linux-gcc-6.3.1/bin:/home/ovalgee/Projects/iSCARA/Linux/toolchain/i686-linux-gcc-5.1.0/bin:$PATH
	export LD_LIBRARY_PATH=/home/ovalgee/Projects/iSCARA/Linux/toolchain/i686-linux-gcc-5.1.0/lib:$LD_LIBRARY_PATH
	qtdir=$topdir/lib/qt
elif [ -d "/dobot/bin" ]; then
	topdir=/dobot/bin
	qtdir=/usr/local/qt-4.8.6
else
	echo "You must indicat path"
	exit 1
fi

tmpdir=$topdir/tmp

export LD_LIBRARY_PATH=$topdir/lib:$qtdir/lib:$LD_LIBRARY_PATH
export PATH=$PYTHONHOME/bin:$PATH

export LUA_PATH=$topdir/lua/?.lua
export LUA_CPATH=$topdir/lib/?.so

#clean tmp dir
rm -rf $tmpdir
mkdir -p $tmpdir
mkdir -p $tmpdir/smb
rm -f /project
ln -s $topdir/project /project

#check dir
if [ ! -d "log" ]; then
	mkdir log
fi
if [ ! -f "$topdir/etc/version.conf" ]; then
	echo "010000" > $topdir/etc/version.conf
fi

#log setting
logcntfile=$topdir/log/cnt.conf
logtypefile=$topdir/log/type.conf
logtempfile=/tmp/log_temp.conf
if [ ! -f "$logtypefile" ]; then
	echo file > $logtypefile
fi
logtype=$(cat ${logtypefile}) #stdout, socket, file
if [ -f "$logcntfile" ]; then
	logcnt=`awk '{print NR}' ${logcntfile}|tail -n1`
	allcount=`head -1 ${logcntfile}`
	if [ $logcnt -gt $allcount ]; then
		delfile=`sed -n '2p' ${logcntfile}`
		sed -i '2d' $logcntfile;
		rm -rf log/$delfile
	fi
fi

if [ ! -d "/dobot/data/redis_cache" ]; then
	mkdir -p /dobot/data/redis_cache
	#mount /dev/mmcblk3p4 /dobot/data/
fi

chmod 777 -R /dobot/bin
rm /dobot/data/redis_cache/stdout -f
/dobot/bin/bin/redis-server /dobot/bin/etc/redis.conf
#  change mac to setted
if [ -f "/etc/mac" ]; then
	echo set mac to $(cat /etc/mac)
	/sbin/ifconfig eth2 down
	/sbin/ifconfig eth2 hw ether $(cat /etc/mac)
	/sbin/ifconfig eth2 up
	/sbin/ifconfig eth1 down
	/sbin/ifconfig eth1 hw ether $(cat /etc/mac)
	/sbin/ifconfig eth1 up
fi
#start smb
/dobot/bin/bin/nmbd -s /dobot/bin/etc/smb.conf -D &
/dobot/bin/bin/smbd -s /dobot/bin/etc/smb.conf -D &

ifconfig eth2 192.168.5.1 netmask 255.255.255.0

option="${1}"
case ${option} in
    -codesys)
        echo "[start] codesys"
	      if [ "$logtype" == "file" ]; then
	      	if [ ! -f "$logcntfile" ]; then
	 			echo 30 > $logcntfile
	  		fi
	  		logf=`cat /dev/urandom | head -n 10 | md5sum | head -c 10`
	     	echo $logf >> $logcntfile
	 		echo $logf > $logtempfile
	 		sync
	      fi       
		chmod +x /dobot/bin/gcontrol                                                                                                                              
        cd /opt/codesys/Platforms/Linux/Bin                                                              
        ./codesysload -d& 
		sleep 1
		/dobot/bin/gcontrol &
        ;;
   -env)
	 echo "LD_LIBRARY_PATH=$LD_LIBRARY_PATH"
	 echo "PATH=$PATH"
      ;;
   -dobot) 
      echo "[start] iscara"
      if [ "$logtype" == "file" ]; then
      	if [ ! -f "$logcntfile" ]; then
 			echo 30 > $logcntfile
  		fi
  		logf=`cat /dev/urandom | head -n 10 | md5sum | head -c 10`
     	echo $logf >> $logcntfile
 		echo $logf > $logtempfile
 		sync
      fi
	  ./iscara
	  ;;
	-clog)
		echo "[start] clear all log"
	  	if [ -f "$logcntfile" ]; then
			allcount=1
			if [ "$logtype" == "file" ]; then
				allcount=2
			fi
			logcnt=`awk '{print NR}' ${logcntfile}|tail -n1`
			while [[ $logcnt -gt $allcount ]]  
			do 
				delfile=`sed -n '2p' ${logcntfile}`
				sed -i '2d' $logcntfile
				if [ -f "log/$delfile" ]; then
					rm -rf log/$delfile
				fi
				logcnt=`awk '{print NR}' ${logcntfile}|tail -n1`
			done
		fi
	  ;;
   *)
	  echo "`basename ${0}`:usage: "
	  echo "codesys"	"start codesys"
	  echo "[-env]   	echo current environment"
	  echo "[-dobot]  	start scara"
	  echo "[-clog]   	clear all log"
      exit 1 # Command to come out of the program with status 1
      ;;

esac
